## UDisksManagerZRAM UDisksManagerZRAM — Generated C code for the org.freedesktop.UDisks2.Manager.ZRAM D-Bus interface |

## Functions

void | udisks_manager_zram_call_create_devices ()
gboolean | udisks_manager_zram_call_create_devices_finish ()
gboolean | udisks_manager_zram_call_create_devices_sync ()
void | udisks_manager_zram_call_destroy_devices ()
gboolean | udisks_manager_zram_call_destroy_devices_finish ()
gboolean | udisks_manager_zram_call_destroy_devices_sync ()
void | udisks_manager_zram_complete_create_devices ()
void | udisks_manager_zram_complete_destroy_devices ()
GDBusInterfaceInfo * | udisks_manager_zram_interface_info ()
guint | udisks_manager_zram_override_properties ()
void | udisks_manager_zram_proxy_new ()
UDisksManagerZRAM * | udisks_manager_zram_proxy_new_finish ()
void | udisks_manager_zram_proxy_new_for_bus ()
UDisksManagerZRAM * | udisks_manager_zram_proxy_new_for_bus_finish ()
UDisksManagerZRAM * | udisks_manager_zram_proxy_new_for_bus_sync ()
UDisksManagerZRAM * | udisks_manager_zram_proxy_new_sync ()
UDisksManagerZRAM * | udisks_manager_zram_skeleton_new ()

## Signals

gboolean | handle-create-devices | Run Last
gboolean | handle-destroy-devices | Run Last

## Types and Values

| UDisksManagerZRAM
struct | UDisksManagerZRAMIface
struct | UDisksManagerZRAMProxy
struct | UDisksManagerZRAMProxyClass
struct | UDisksManagerZRAMSkeleton
struct | UDisksManagerZRAMSkeletonClass

## Object Hierarchy

        GInterface
        ╰── UDisksManagerZRAM
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── UDisksManagerZRAMSkeleton
        ╰── GDBusProxy
            ╰── UDisksManagerZRAMProxy

## Prerequisites

UDisksManagerZRAM requires GObject.

## Implemented Interfaces

UDisksManagerZRAMProxy implements GDBusInterface, GInitable, GAsyncInitable and UDisksManagerZRAM.

UDisksManagerZRAMSkeleton implements GDBusInterface and UDisksManagerZRAM.

## Known Implementations

UDisksManagerZRAM is implemented by UDisksManagerZRAMProxy and UDisksManagerZRAMSkeleton.

## Description

This section contains code for working with the org.freedesktop.UDisks2.Manager.ZRAM D-Bus interface in C.

## Functions

### udisks_manager_zram_call_create_devices ()

    void
    udisks_manager_zram_call_create_devices
                                   (UDisksManagerZRAM *proxy,
                                    GVariant *arg_sizes,
                                    GVariant *arg_num_streams,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CreateDevices()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `udisks_manager_zram_call_create_devices_finish()` to get the result of the operation.

See `udisks_manager_zram_call_create_devices_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
arg_sizes | Argument to pass with the method invocation. |
arg_num_streams | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.3.0

### udisks_manager_zram_call_create_devices_finish ()

    gboolean
    udisks_manager_zram_call_create_devices_finish
                                   (UDisksManagerZRAM *proxy,
                                    gchar ***out_zrams,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_manager_zram_call_create_devices()`.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
out_zrams | Return location for return parameter or `NULL` to ignore. | [out][array zero-terminated=1]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_manager_zram_call_create_devices()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.3.0

### udisks_manager_zram_call_create_devices_sync ()

    gboolean
    udisks_manager_zram_call_create_devices_sync
                                   (UDisksManagerZRAM *proxy,
                                    GVariant *arg_sizes,
                                    GVariant *arg_num_streams,
                                    GVariant *arg_options,
                                    gchar ***out_zrams,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CreateDevices()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_manager_zram_call_create_devices()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
arg_sizes | Argument to pass with the method invocation. |
arg_num_streams | Argument to pass with the method invocation. |
arg_options | Argument to pass with the method invocation. |
out_zrams | Return location for return parameter or `NULL` to ignore. | [out][array zero-terminated=1]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.3.0

### udisks_manager_zram_call_destroy_devices ()

    void
    udisks_manager_zram_call_destroy_devices
                                   (UDisksManagerZRAM *proxy,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `DestroyDevices()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `udisks_manager_zram_call_destroy_devices_finish()` to get the result of the operation.

See `udisks_manager_zram_call_destroy_devices_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 2.3.0

### udisks_manager_zram_call_destroy_devices_finish ()

    gboolean
    udisks_manager_zram_call_destroy_devices_finish
                                   (UDisksManagerZRAM *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_manager_zram_call_destroy_devices()`.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_manager_zram_call_destroy_devices()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.3.0

### udisks_manager_zram_call_destroy_devices_sync ()

    gboolean
    udisks_manager_zram_call_destroy_devices_sync
                                   (UDisksManagerZRAM *proxy,
                                    GVariant *arg_options,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `DestroyDevices()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `udisks_manager_zram_call_destroy_devices()` for the asynchronous version of this method.

#### Parameters

proxy | A UDisksManagerZRAMProxy. |
arg_options | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 2.3.0

### udisks_manager_zram_complete_create_devices ()

    void
    udisks_manager_zram_complete_create_devices
                                   (UDisksManagerZRAM *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *const *zrams);

Helper function used in service implementations to finish handling invocations of the `CreateDevices()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksManagerZRAM. |
invocation | A GDBusMethodInvocation. | [transfer full]
zrams | Parameter to return. |

Since: 2.3.0

### udisks_manager_zram_complete_destroy_devices ()

    void
    udisks_manager_zram_complete_destroy_devices
                                   (UDisksManagerZRAM *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `DestroyDevices()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A UDisksManagerZRAM. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 2.3.0

### udisks_manager_zram_interface_info ()

    GDBusInterfaceInfo *
    udisks_manager_zram_interface_info (void);

Gets a machine-readable description of the org.freedesktop.UDisks2.Manager.ZRAM D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

Since: 2.3.0

### udisks_manager_zram_override_properties ()

    guint
    udisks_manager_zram_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the UDisksManagerZRAM interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

Since: 2.3.0

### udisks_manager_zram_proxy_new ()

    void
    udisks_manager_zram_proxy_new (GDBusConnection *connection,
                                   GDBusProxyFlags flags,
                                   const gchar *name,
                                   const gchar *object_path,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.freedesktop.UDisks2.Manager.ZRAM. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `udisks_manager_zram_proxy_new_finish()` to get the result of the operation.

See `udisks_manager_zram_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 2.3.0

### udisks_manager_zram_proxy_new_finish ()

    UDisksManagerZRAM *
    udisks_manager_zram_proxy_new_finish (GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `udisks_manager_zram_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_manager_zram_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksManagerZRAMProxy]

Since: 2.3.0

### udisks_manager_zram_proxy_new_for_bus ()

    void
    udisks_manager_zram_proxy_new_for_bus (GBusType bus_type,
                                           GDBusProxyFlags flags,
                                           const gchar *name,
                                           const gchar *object_path,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

Like `udisks_manager_zram_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `udisks_manager_zram_proxy_new_for_bus_finish()` to get the result of the operation.

See `udisks_manager_zram_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 2.3.0

### udisks_manager_zram_proxy_new_for_bus_finish ()

    UDisksManagerZRAM *
    udisks_manager_zram_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `udisks_manager_zram_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `udisks_manager_zram_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksManagerZRAMProxy]

Since: 2.3.0

### udisks_manager_zram_proxy_new_for_bus_sync ()

    UDisksManagerZRAM *
    udisks_manager_zram_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `udisks_manager_zram_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `udisks_manager_zram_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksManagerZRAMProxy]

Since: 2.3.0

### udisks_manager_zram_proxy_new_sync ()

    UDisksManagerZRAM *
    udisks_manager_zram_proxy_new_sync (GDBusConnection *connection,
                                        GDBusProxyFlags flags,
                                        const gchar *name,
                                        const gchar *object_path,
                                        GCancellable *cancellable,
                                        GError **error);

Synchronously creates a proxy for the D-Bus interface org.freedesktop.UDisks2.Manager.ZRAM. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `udisks_manager_zram_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type UDisksManagerZRAMProxy]

Since: 2.3.0

### udisks_manager_zram_skeleton_new ()

    UDisksManagerZRAM *
    udisks_manager_zram_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.freedesktop.UDisks2.Manager.ZRAM.

#### Returns

The skeleton object.

[transfer full][type UDisksManagerZRAMSkeleton]

Since: 2.3.0

## Types and Values

### UDisksManagerZRAM

    typedef struct _UDisksManagerZRAM UDisksManagerZRAM;

Abstract interface type for the D-Bus interface org.freedesktop.UDisks2.Manager.ZRAM.

Since: 2.3.0

### struct UDisksManagerZRAMIface

    struct UDisksManagerZRAMIface {
      GTypeInterface parent_iface;

      gboolean (*handle_create_devices) (
        UDisksManagerZRAM *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_sizes,
        GVariant *arg_num_streams,
        GVariant *arg_options);

      gboolean (*handle_destroy_devices) (
        UDisksManagerZRAM *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_options);
    };

Virtual table for the D-Bus interface org.freedesktop.UDisks2.Manager.ZRAM.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_create_devices` () | Handler for the “handle-create-devices” signal. |
`handle_destroy_devices` () | Handler for the “handle-destroy-devices” signal. |

Since: 2.3.0

### struct UDisksManagerZRAMProxy

    struct UDisksManagerZRAMProxy;

The UDisksManagerZRAMProxy structure contains only private data and should only be accessed using the provided API.

Since: 2.3.0

### struct UDisksManagerZRAMProxyClass

    struct UDisksManagerZRAMProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for UDisksManagerZRAMProxy.

#### Members

Since: 2.3.0

### struct UDisksManagerZRAMSkeleton

    struct UDisksManagerZRAMSkeleton;

The UDisksManagerZRAMSkeleton structure contains only private data and should only be accessed using the provided API.

Since: 2.3.0

### struct UDisksManagerZRAMSkeletonClass

    struct UDisksManagerZRAMSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for UDisksManagerZRAMSkeleton.

#### Members

Since: 2.3.0

## Signal Details

### The `“handle-create-devices”` signal

    gboolean
    user_function (UDisksManagerZRAM     *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_sizes,
                   GVariant              *arg_num_streams,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CreateDevices()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_manager_zram_complete_create_devices()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksManagerZRAM. |
invocation | A GDBusMethodInvocation. |
arg_sizes | Argument passed by remote caller. |
arg_num_streams | Argument passed by remote caller. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.3.0

### The `“handle-destroy-devices”` signal

    gboolean
    user_function (UDisksManagerZRAM     *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_options,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `DestroyDevices()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `udisks_manager_zram_complete_destroy_devices()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A UDisksManagerZRAM. |
invocation | A GDBusMethodInvocation. |
arg_options | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 2.3.0